﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using Telerik.Windows.Controls.ChartView;
using Telerik.Windows.Controls.ScheduleView;

namespace BaseSLProject
{
    public partial class MainPage : UserControl
    {
        //public ObservableCollection MyProperty { get; set; }

        public MainPage()
        {
            InitializeComponent();
            this.chart.SeriesProvider.SeriesDescriptors.First().Style = this.Resources["barCategoricalSeriesDescriptorStyle"] as Style;
            
        }

        private void ChartType_SelectionChanged_1(object sender, SelectionChangedEventArgs e)
        {
            var listBox = sender as ListBox;
            ChartType type = ((ChartType)listBox.SelectedItem);

            if (type.ChartSeriesType == ChartSeriesType.Bar)
            {
                if (this.chart != null && this.chart.Visibility == Visibility.Collapsed)
                {
                    this.chart.Visibility = Visibility.Visible;
                    this.pieChart.Visibility = Visibility.Collapsed;
                }
                this.RefreshChartType(this.Resources["barCategoricalSeriesDescriptorStyle"] as Style);
                
            }
            else if (type.ChartSeriesType == ChartSeriesType.Area)
            {
                if (this.chart != null && this.chart.Visibility == Visibility.Collapsed)
                {
                    this.chart.Visibility = Visibility.Visible;
                    this.pieChart.Visibility = Visibility.Collapsed;
                }
                this.RefreshChartType(this.Resources["areaCategoricalSeriesDescriptorStyle"] as Style);
            }
            else if (type.ChartSeriesType == ChartSeriesType.Line)
            {
                if (this.chart != null && this.chart.Visibility == Visibility.Collapsed)
                {
                    this.chart.Visibility = Visibility.Visible;
                    this.pieChart.Visibility = Visibility.Collapsed;
                }
                this.RefreshChartType(this.Resources["lineCategoricalSeriesDescriptorStyle"] as Style);
            }
            else if (type.ChartSeriesType == ChartSeriesType.Pie)
            {
                if (this.pieChart != null && this.chart != null)
                {
                    this.pieChart.Visibility = Visibility.Visible;
                    this.chart.Visibility = Visibility.Collapsed;
                }
                
            }
        }

        private void RefreshChartType(Style style)
        {
            if (this.chart != null)
            {
                this.chart.SeriesProvider.SeriesDescriptors.First().Style = style;
                this.chart.SeriesProvider.RefreshAttachedCharts();
            }            
        }

    }

    public class SeriesSourceNameToSeriesLegendSettigsConverter : IValueConverter
    {
        public object Convert(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            return new SeriesLegendSettings() { Title = value.ToString() };
        }

        public object ConvertBack(object value, Type targetType, object parameter, System.Globalization.CultureInfo culture)
        {
            throw new NotImplementedException();
        }
    }

    public enum ChartSeriesType
    {
        Bar,
        Area,
        Line,
        Pie
    }

    public class ChartType
    {
        public ChartSeriesType ChartSeriesType { get; set; }
    }
}
